<template>
  <q-page padding>
    <q-table
      row-key="id"
      :columns="columns"
      :data="brands"
      :filter="filter"
    >
      <template v-slot:top-left>
        <div class="text-h6">Marcas <q-btn color="primary" icon-right="fas fa-plus-circle" label="Crear" @click="add" /></div>
      </template>
      <template v-slot:top-right>
        <q-input borderless debounce="300" v-model="filter" placeholder="Buscar">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>
      <template v-slot:body-cell-action="props">
        <td class="text-right">
          <q-btn-group>
            <q-btn color="primary" icon="fas fa-edit" size="0.75em" @click="edit(props.row)" />
            <q-btn color="primary" icon="fas fa-trash-alt" size="0.75em" @click="destroy({ id: props.row._id, index: props.row.__index })" />
          </q-btn-group>
        </td>
      </template>
    </q-table>
    <router-view />
  </q-page>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  data () {
    return {
      columns: [
        { name: 'name', label: 'Nombre', field: row => row.name },
        { name: 'enabled', label: 'Habilitado', field: row => row.enabled },
        { name: 'action', label: 'Acciones', align: 'center' }
      ],
      filter: null
    }
  },
  mounted () {
    this.$store.dispatch('adminBrand/getAll')
  },
  computed: {
    ...mapGetters({
      brands: 'adminBrand/all'
    })
  },
  methods: {
    add () {
      this.$router.push({ name: 'admin.article.brand.create' })
    },
    edit (brand) {
      this.$router.push({ name: 'admin.article.brand.edit', params: { brand_id: brand._id }, query: { index: brand.__index } })
    },
    destroy ({ id, index }) {
      this.$q.dialog({
        title: 'Confirmar',
        message: '¿Está seguro de eliminar el registro?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        let query, color, icon
        try {
          query = await this.$store.dispatch('adminBrand/destroy', { id, index })
          color = 'info'
          icon = 'sentiment_satisfied'
        } catch (err) {
          query = err
          color = 'negative'
          icon = 'sentiment_dissatisfied'
        }
        const { message } = query
        this.$q.notify({
          position: 'top',
          message,
          color,
          icon
        })
      })
    }
  }
}
</script>
